package com.malk.kuaikeli.controller;

import com.alibaba.fastjson.JSON;
import com.malk.server.aliwork.YDConf;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDService;
import com.malk.utils.UtilMc;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 错误抛出与拦截详见 CatchException
 */
@Slf4j
@RestController
@RequestMapping()
public class KKLController {

    @Autowired
    private YDService ydService;

    @PostMapping("supplier")
    McR supplier(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("supplier, {}", JSON.toJSONString(data));

        // ppExt: 供应商区分发起: 当前表：供应供子表组件ID，子表内供应商编号，名称，负责人
        String[] compIds_supplier = String.valueOf(data.get("compId_supplier")).split(", ");
        String compId_supplier = compIds_supplier[1];

        Map formData = (Map) JSON.parse(String.valueOf(data.get("formData")));
        List<Map> details = (List<Map>) formData.get(compIds_supplier[0]);

        // 供应商编号, 数据去重: 提取数据区分供应商发起
        List<Map> suppliers = UtilMc.distinctByKey(details, compId_supplier);
        for (Map supplier : suppliers) {
            List<Map> dataList = details.stream().filter(item -> supplier.get(compId_supplier).equals(item.get(compId_supplier))).collect(Collectors.toList());
            formData.put(compIds_supplier[0], dataList);
            // ppExt: 参数传递, 目标表组件ID, 对照当前表子表内的子表内供应商编号，名称，负责人已放置主表字段, 此处公共内容提前首条数据进行赋值
            for (int i = 1; i < compIds_supplier.length; i++) {
                formData.put(compIds_supplier[i], YDConf.getDataByCompId(dataList.get(0), compIds_supplier[i]));
            }
            data.put("formData", JSON.toJSONString(formData));
            ydService.copyFormData(data); // 发起流程
        }
        return McR.success();
    }

    @PostMapping("test")
    McR test(HttpServletRequest request) {


        Map data = UtilServlet.getParamMap(request);

        log.info("xxxx, {}", data);

        return McR.success();
    }

}
